Visit Our UNIX and Linux User Community


Equivalents of tee command to find exit status of command


 
Thread Tools Search this Thread
Top Forums UNIX for Advanced & Expert Users Equivalents of tee command to find exit status of command
# 1  
Old 06-02-2011
Equivalents of tee command to find exit status of command

Hi,

Want to log the output of command & check the exit status to find whether it succeeded or failed.

> ls abc
ls: abc: No such file or directory
> echo $?
1

> ls abc 2>&1 | tee log
ls: abc: No such file or directory
> echo $?
0

Tee commands changes my exit status to be always successful as tee was successful. Smilie

Kindly let me know the options via which I can obtain the exit status of command while having the output stream flowing on the terminal.

Thanks in advance.
# 2  
Old 06-02-2011
try this... not tested...
Code:
ls abc 2>&1 | tee log &&  echo  $? || echo $?

# 3  
Old 06-02-2011
Getting success, return code of 0

ls abc 2>&1 | tee log && echo $? || echo $?
ls: abc: No such file or directory
0
# 4  
Old 06-02-2011
Code:
ls abc 2>&1 > log 
echo  $?

# 5  
Old 06-02-2011
That won't give me the output on terminal.
I can later cat or tail it, but it won't be simultaneous.

I want to monitor the progress on my terminal & log the output for later reference.
# 6  
Old 06-02-2011
This is a bit of a kludge, using a temporary file to hold the exit status, but it works:

Code:
(ls abc 2>&1; echo $? > tmpfile.$$) | tee log; cat tmpfile.$$; rm -f tmpfile.$$

# 7  
Old 06-02-2011
Another option:

Code:
$ ls abc 2>&1 | tee log
ls: abc: No such file or directory
$ echo $?
0

$ set -o pipefail
$ ls abc 2>&1 | tee log
ls: abc: No such file or directory
$ echo $?
1

This User Gave Thanks to Scott For This Post:

Previous Thread | Next Thread
Test Your Knowledge in Computers #520
Difficulty: Easy
In general, any number in base-10 can be written as the summation of powers of 10 multiplied by the numbers 0 through 9.
True or False?

10 More Discussions You Might Find Interesting

1. Shell Programming and Scripting

Exit Status of Command

Hi All, I am doing an export and import (datapump) of 4 schema. I know we can do an export of 4 schema in one command. But just want to know how to check the exit status if i do the export/import of 4 schema in different commands in background. Please suggest. Thanks, Mani (1 Reply)
Discussion started by: pvmanikandan
1 Replies

2. UNIX for Dummies Questions & Answers

Exit Status Of Find Command

Hello All, I am trying to capture the exit status of find command and want to delete the files only when it is successful. But it is always returning me as success even if the pattern of that file doesn't exist in the current directory. please help, checked manual page but couldn't able to figure... (6 Replies)
Discussion started by: Ariean
6 Replies

3. Shell Programming and Scripting

Unable to find exit status of piped command

Lois_Answer_Code=`sipsak -vv -s sip:192.168.1.3|grep -A 1 "reply received after"|grep SIP|awk '{print $2}'`How to find the exit status of | (12 Replies)
Discussion started by: proactiveaditya
12 Replies

4. HP-UX

Logins command exit status is 236 not 0

I have noticed that on version 11.23 I get exit status 236 from the following command: logins -oxl root ; echo $? > 236 However on 11.31 I get the expected code 0 logins -oxl root ; echo $? > 0 The output is correct for both versions and contains no error data. Can anyone explain... (2 Replies)
Discussion started by: parkea2
2 Replies

5. Shell Programming and Scripting

command does not return exit status due to tee

Hi, I am using /bin/sh. I want to display the stdout and stderr on the terminal as well as save it in a file, so I'm using this command. gmake all 2>&1 | tee log But even if gmake fails, it's always giving 0 as exit status, i suppose because of tee. # false 2>&1 | tee Log # echo $? 0... (2 Replies)
Discussion started by: anand_bh
2 Replies

6. Shell Programming and Scripting

Move Command and exit status problem

Hi All, I am using the following code to move files from one folder to another on the remote server: ssh username@server <<EOF cd source_dir find . -type f -name "*.txt" |xargs -n1000 -i{} mv {} dest_dir if then send mail indicating error otherwise echo "success" fi EOF ... (10 Replies)
Discussion started by: visingha
10 Replies

7. UNIX for Dummies Questions & Answers

Move Command and exit status problem

Hi All, I am using the following code to move files from one folder to another on the remote server: ssh username@server <<EOF cd source_dir find . -type f -name "*.txt" |xargs -n1000 -i{} mv {} dest_dir if then send mail indicating error otherwise echo "success" fi EOF ... (1 Reply)
Discussion started by: visingha
1 Replies

8. Shell Programming and Scripting

Getting the exit status of a remote command

Hi to everyone. How can I get the exit status from a remote command executed with rexec? :eek: machine A has RedHat Linux 9 and the remote machine B has SCO UNIX. Code: rexec -l user -p password host sh /u/files/scripts/seq_cal.sh 2006 08 I want the exit status returned by... (1 Reply)
Discussion started by: zoonalex
1 Replies

9. UNIX for Dummies Questions & Answers

how to find the exit status for the last executed command

I am executing a find command in my script i.e find $2 -type f -name '*.gif' -mtime +$1 -exec rm {} \; how do i check that this command is executed properly.. i would lke t trap the errror and display my error message kinly help.. this is an urgent issue. (1 Reply)
Discussion started by: vijay.amirthraj
1 Replies

10. Programming

How to find the exit status of last command in Unix?

Hi, I want to find the exit status of the last executed command in C Shell. Tried $? but getting the error Variable syntax...$? does not seem to work in C shell.. is there any other command in C shell to find the exit status of last command? Thanks in advance, raju (1 Reply)
Discussion started by: rajugp1
1 Replies

Featured Tech Videos